unit Unit2;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, Forms;

{$IFNDEF LINUX}
   const fspecLog = 'x:\test.log'; // path + name of logfile
{$ELSE}
   const fspecLog = '/media/X/test.log';
{$ENDIF}

type

 { TDataModule1 }

 TDataModule1 = class(TDataModule)
   ApplicationProperties1: TApplicationProperties;
   procedure ApplicationProperties1EndSession(Sender: TObject);
 private
 public
 end;

var
 DataModule1: TDataModule1;

procedure AppendToFile(const FileName, Data: string);

implementation

{$R *.lfm}

procedure AppendToFile(const FileName, Data: string);
var
  Stream: TFileStream;
  EndOfLine: string;
begin
  try
    Stream := TFileStream.Create(FileName, fmOpenWrite);
  except
    on E: EFOpenError do
      Stream := TFileStream.Create(FileName, fmCreate);
  end;
  try
    Stream.Seek(0, soFromEnd);
    Stream.WriteBuffer(Pointer(Data)^, Length(Data) * SizeOf(Char));
    EndOfLine := LineEnding;
    Stream.WriteBuffer(Pointer(EndOfLine)^, Length(EndOfLine) * SizeOf(Char));
  finally
    Stream.Free;
  end;
end;

{ TDataModule1 }

procedure TDataModule1.ApplicationProperties1EndSession(Sender: TObject);
begin
  AppendToFile(fspecLog, 'terminated');
end;

end.

